// Genesaver: copyright 2003 Sam Stafford.

//Enums, constants, and the like.
enum Color { Black, Grey, Green, Red, Blue, Yellow, Cyan, Magenta };

struct Settings
{
	bool AA;
	bool AAline;
	bool shade;
	bool save;
	short mutate;
	short plants; // per 1000 ticks
	short cscale;
	short camera;
	int gticks; // timesteps per screen
	short gwidth; // data points per screen
	short zoom;
	bool wake;
	bool drawvis;
	bool lizard;

	float alpha; //state variable, not setting
};

struct FSettings
{
	float gtime;
	float gstep;
	float ps;
	float pr;
	float ar;
	float am;
	float as;
	float av;
};

extern Settings settings;
extern FSettings fsettings;

#define NULL 0		//null

#define P_E 500.0  	//Plant energy
#define P_R fsettings.pr 	//Plant radius
#define P_C Grey 	//Plant color
#define P_S	fsettings.ps
	//Plant spawning ( number of plants to spawn per step )

#define A_E 300.0  	//Animal energy
#define A_R fsettings.ar	//Animal radius
#define A_M fsettings.am	//Animal metabolism ( A_M * dist = energy used )
#define A_Z 0.05 	//Resting metabolism ( energy used per step )
#define A_D 0.4		//Animal digestion ( A_D * input = energy gained )
#define A_B	-1.5	//Animal backup ( factor of extra energy burned )
#define A_S	fsettings.as	//Animal speed ( length of max step )
#define A_T 0.5  	//Animal turning ( max turn step, radians )
#define A_C	20		//Number of steps an animal needs to chew
#define A_V fsettings.av	//Visual distance
#define A_A 1		//Wide angle of view
#define A_L 0.2		//"Lookat" angle of view

#define D_M settings.mutate	//Number of times to mutate DNA on a split

#define N_R 0.015	//Neuron radius when rendering brain
#define N_L 0.03	//Neuron label "radius"

#define C_WORLD 1	//"World" camera setting
#define C_CHASE 2	//"Chase" camera setting
#define C_GRAPH 3	//"Graph" camera setting

#define G_TIME fsettings.gtime
					//Ticks per graph point
#define G_STEP fsettings.gstep
					//Width in screen coords tween points

float RandFloat();	//Random float between 0 and 1.
int RandInt( int );	//Random int between 0 and int.
void SetColor( Color );
void SetColor21( Color, float );
void SetHue( float );

